#import "fontawesome.typ": *
#import "lib.typ": template, education_entry, work_entry, project, indent

#set page(margin: 1.75in)
#set par(leading: 0.5em, first-line-indent: 1.8em, justify: true)
#show raw: set text(font: "New Computer Modern Mono")
#show par: set block(spacing: 0.55em)
#show heading: set block(above: 2em, below: 1em)

#set list(indent: 1em)

// Change the theme color of the cv.
#let color = black
#let name = "Daniel Chen"

#let contact_data = (
  (
    service: fa[#globe],
    display: "eggworld.me",
    link: "https://eggworld.me"
  ),
  (
    service: fa[#github],
    display: "potatoeggy",
    link: "https://github.com/potatoeggy"
  ),
  (
    service: fa[#linkedin],
    display: "potatoeggy",
    link: "https://www.linkedin.com/in/potatoeggy/"
  ),
  (
    service: fa[#envelope],
    display: "daniel.chen1@uwaterloo.ca",
    link: "mailto://daniel.chen1@uwaterloo.ca"
  ),
)

#show: doc => template(name, contact_data, color, doc)

// MAIN CONTENT STARTS here

= Skills

#indent[
    *Languages*: Python, JavaScript/TypeScript, Rust, SQL, C++, HTML, CSS, Bash, Java \
    *Frameworks*: Node.js, Express, React, Next.js, Vue, Flutter, Qt, Prisma, Apollo \
    *Tools*: Linux, Git, Docker, Postgres, Kubernetes, AWS, GCP, Terraform
]

= Experience

#indent[
#work_entry(
  "Software Engineering Intern",
  "Dropbase",
  start_date: "May 2023", end_date: "Aug 2023",
  location: "Remote",
  tasks: (
    "??? Query builder ORM",
    "??? Integrating Airtable/HubSpot w/AWS Lambda",
    "??? Major frontend refactor",
    "??? Dropbase things"
  )
)

#work_entry(
  "Backend Developer",
  "Techyon",
  start_date: "Mar 2023", end_date: "present",
  location: "Waterloo, ON",
  tasks: (
    "??? Telemetry and observability w/K8s, Grafana, OpenTelemetry",
    "??? Registration ticket w/Apollo Server + GraphQL, w/Google + Apple Wallet",
    "??? Went back and documented old code and endpoints for FE, APOLLO UPGRADE",
    "??? Provisioned more Redis instances to avoid downtime"
  )
)
]

= GitHub Projects

#indent[
#project("Mandown", "https://github.com/potatoeggy/mandown", "Python, Qt")
- Created a real-time site scraper for metadata and images to automatically download comics
- Implemented comic conversion between CBZ/EPUB/PDF as well as image processing to optimise for e-ink screens
- Increased download and update speed by more than 100% by implementing image caching and multiprocessing
- Designed a responsive and accessible CLI with Typer and GUI with Qt 6
- Wrote extensive unit tests to minimise regressions between release cycles

#project("Kobink", "https://github.com/potatoeggy/kobink", "Rust, Axum, Postgres")
- ??? something here
- ??? something here

#project("RecipeReady", "https://github.com/github.com/vincentjguo/recipeready-server", "Flutter, Selenium, FastAPI, Android")
- Scraped thousands of websites for recipes to build a database with a robust many-to-many tag system
- Designed a REST API to filter and query recipes along with ingredient pricing from Walmart

#project("\"Pillow\" Water Quality Sensor", "https://github.com/potatoeggy/ece198", "Rust, STM32")
- Created a water quality statistics aggregator and visualiser on an embedded platform in safe Rust
- Engineered an embedded system with a STM32 microcontroller, matrix keypad, and an LCD display

#project("Primoprod", "https://github.com/potatoeggy/primoprod", "Vue, TypeScript")
- Mocked a video game UI using CSS to create a hyper-realistic, cross-platform game simulator
- Reverse-engineered an API to allow Primoprod to interoperate with a popular web service (paimon.moe)
]

= Awards

- Winner of the EdTech category at StormHacks 2022
- Winner of the IBM Open Source category at YRHacks 2022
- 2nd place in the Industry 4.0 engineering analytics competition

= Education

#indent[
#education_entry("University of Waterloo", "Candidate for B.A.Sc. in Computer Engineering", start_date: "Sep 2022", end_date: "present",
location: "Waterloo, ON", details: (
  [Secretary, Creative Writing Club],
))
]